function hideAll() {
    $('#meetingDate').parent().hide();
    $('#meetingTime').parent().hide();
    $('#degreeSelect').parent().show();
    // $('#fieldSelect').parent().hide();
    $('#programSelect').parent().hide();
}
function showPhysical() {
    current_dates = PHYSICAL_DATES
    current_interval = PHYSICAL_TIMES_INTERVAL
    current_min_max = PHYSICAL_TIMES_MIN_MAX
	meetingThreshold = 14;
    $('#meetingDate').parent().show();
    $('#meetingTime').parent().hide();
    $('#fieldSelect').parent().show();
    $('#programSelect').parent().show();
    // $('#degreeSelect option[value="1"]').hide();
}
function showPhone() {
    $('#fieldSelect').parent().show();
    $('#programSelect').parent().show();
    $('#degreeSelect').parent().show();
	$('#myform').attr('action','https://www.leadock.com/pages/formHandler');
    // $('#degreeSelect option[value="1"]').show();
}
function showZoom() {
    current_dates = ZOOM_DATES
    current_interval = ZOOM_TIMES_INTERVAL
    current_min_max = ZOOM_TIMES_MIN_MAX
    $('#meetingDate').parent().show();
    $('#meetingTime').parent().hide();
    $('#fieldSelect').parent().show();
    $('#programSelect').parent().show();
	meetingThreshold = 3;
    // $('#degreeSelect option[value="1"]').hide();
}
let programs = {}
const days = ['ראשון', 'שני', 'שלישי', 'רביעי', 'חמישי', 'שישי', 'שבת']

const ZOOM_DATES = [[4, 3], [11, 3], [25, 3], [1, 4], [8, 4]]
const ZOOM_TIMES_INTERVAL = 10
const ZOOM_TIMES_MIN_MAX = [10, 12]

const PHYSICAL_DATES = [[5, 3], [12, 3], [19, 3], [26, 3], [2, 4], [9, 4]]
const PHYSICAL_TIMES_INTERVAL = 60
const PHYSICAL_TIMES_MIN_MAX = [10, 13]

let current_dates = ZOOM_DATES
let current_interval = ZOOM_TIMES_INTERVAL
let current_min_max = ZOOM_TIMES_MIN_MAX

function addZero(a) {
    return a < 10 ? `0${a}` : a;
}
function populateDates(dates) {
    console.log(dates);
    //$("#meetingTime").prop('disabled', true);
    $("#meetingDate").empty().append($('<option>', {
        value: '',
        text: 'תאריך מפגש:',
    }));

    for (let [day, month] of dates) {
        const d = new Date(2024, month - 1, day, current_min_max[0])
        $("#meetingDate").append($('<option>', {
            // value: `${d.getFullYear()}`,
            value: `${d.getDate()}.${d.getMonth() + 1}.${d.getFullYear() - 2000}`,
            text: `יום ${days[d.getDay()]} ה- ${d.getDate()}.${d.getMonth() + 1}.${d.getFullYear() - 2000}`
        }));
    }
}
function populateTimes(interval, selectedDate, meetingData) {
    if (meetingData.length <= 0) {
        var parsedData = undefined;
    } else {
        var parsedData = JSON.parse(meetingData);
    }
    $("#meetingTime").empty().append($('<option>', {
        value: '',
        text: 'שעת מפגש:',
    }));
    for (let i = current_min_max[0]; i < current_min_max[1]; i++) {
        for (let j = 0; j < 60; j += interval) {
            const d = new Date(2024, 1, 1, i, j, 0);
            let end = new Date(d)
            end.setMinutes(end.getMinutes() + interval)
            const time = `${d.getHours()}:${addZero(d.getMinutes())}-${end.getHours()}:${addZero(end.getMinutes())}`;
			console.log("Current meetingThreshold:", meetingThreshold);
            if ((parsedData != undefined) && (parsedData[selectedDate + " " + time] >= meetingThreshold)) {
                $("#meetingTime").append($('<option>', {
                    value: time,
                    text: time,
                    disabled: true
                }));
            } else {
                $("#meetingTime").append($('<option>', {
                    value: time,
                    text: time
                }));
            }

        }
    }
}
function populateSelect(selectId, options, selected = 0) {
    const select = $(selectId);
    // Remove all options except the first one
    select.find('option:not(:first)').remove();
    Object.entries(options).forEach(([key, value]) => {
        select.append($('<option>', {
            value: key,
            text: value.label
        }));
    });
    select.val(selected).trigger('change');
    if (selected > 0)
        select.parent().hide();
}

function onChangeDegree() {
    var selectedValue = $('#degreeSelect').val();
    //console.log(selectedValue);
    $('#fieldSelect').hide();
    $('#programSelect').hide();

    if (selectedValue) {
        if (programs[selectedValue] && programs[selectedValue].childs) {
            populateSelect('#fieldSelect', programs[selectedValue].childs);
            $('#fieldSelect').show();
            $('input[name="268"]').val(programs[selectedValue]['label']);
            $('input[name="269"]').val(selectedValue);
        }
    }
    $('#programSelect').hide();
}
function onChangeField() {
    var degreeSelectValue = $('#degreeSelect').val();
    var selectedValue = $(this).val();
    $('#programSelect').hide();
    if (degreeSelectValue && selectedValue) {
        if (programs[degreeSelectValue].childs[selectedValue] && programs[degreeSelectValue].childs[selectedValue].childs) {
            populateSelect('#programSelect', programs[degreeSelectValue].childs[selectedValue].childs);
            $('#programSelect').show();
            $('input[name="270"]').val(programs[degreeSelectValue].childs[selectedValue]['label']);
            $('input[name="271"]').val(programs[degreeSelectValue].childs[selectedValue]['value']);
        }
    }
}
function onChangeProgram() {
    console.log("onChangeProgram()");
    console.log("degreeSelectValue",degreeSelectValue);
    var degreeSelectValue = $('#degreeSelect').val();
    var fieldSelectValue = $('#fieldSelect').val();
    var selectedValue = $(this).val();
    if (selectedValue) {
        var field_value = programs[degreeSelectValue].childs[fieldSelectValue].childs[selectedValue];
        if (programs[degreeSelectValue].childs[fieldSelectValue].childs[selectedValue]) {
            $('input[name="272"]').val(field_value['label']);
            $('input[name="273"]').val(field_value['value']);
        }
    }
}
async function onChangeMain() {
    programs = await $.getJSON('data/programs.json');
    console.log("Loaded Data: ", programs);

    // Show the form and hide the mainSelect dropdown
    $('#myform').show();
    const mainSelect = $(this);
    mainSelect.closest('fieldset').hide(); // Adjust this if mainSelect is not within a fieldset
    const selected = mainSelect.val();
    // Show the "change selection" button
    $('#changeSelection').show();

    hideAll();
    // Logic for showing fields based on selection
    if (selected === 'phone_advice') {
        showPhone();
        populateSelect('#degreeSelect', programs, 0);
    } else {
        if (selected === 'zoom_meeting')
            showZoom();
        else
            showPhysical();
        populateSelect('#degreeSelect', programs, 1);
        onChangeDegree();
        populateDates(current_dates);
    }

}
$(document).ready(function () {
    hideAll();
    $('#degreeSelect').change(onChangeDegree);
    $('#fieldSelect').change(onChangeField);
    $('#programSelect').change(onChangeProgram);
    $('#mainSelect').change(onChangeMain);

    $('#meetingDate').change(function () {
        $('#meetingTime').parent().show();
        var selectedDate = $(this).val();
        populateTimes(current_interval, selectedDate, meetingData)
    });
    $('#changeSelection').click(function () {
        location.reload();
    });
});



setInterval(function () {
    document.getElementById("field_281").value = document.getElementById("meetingDate").value;
    document.getElementById("field_282").value = document.getElementById("meetingTime").value;;
    document.getElementById("field_283").value = document.getElementById("mainSelect").value;;
}, 100);
